/*****************************************************************************
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *~                             IR Kernel                                    ~
 *~                         Copyright(C) 1993                                ~
 *~                       Software Kinetics Ltd.                             ~
 *~                        All Rights Reserved                               ~
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Copyright Software Kinetics Ltd.
 * 
 * Software Kinetics Ltd. has granted a licence of this software to
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve,
 * reproduce and sell the software.
 *
 * The software is provided to the user "as is" without warranty of
 * any kind.  Neither Software Kinetics Ltd. nor the National Library
 * of Canada warrants,guarantees or makes any representation regarding
 * the use, or the results of the use of the software in terms of
 * accuracy,reliability, or otherwise.  The entire risk as results and
 * performance of the software is assumed by the user. Neither
 * Software Kinetics Ltd. nor the National Library of Canada shall be
 * liable for any direct, indirect, consequential or incidental
 * damages arising out the use of software.
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 *
 * Header:  irirerror.h
 *
 * Purpose: IR error header file.
 *
 * Index:   section number
 *          section description
 *
 * Version: 93/05/12
 *          Benjamin Yen
 *          reason for change
 *
 * Notes:
 *
 * $Id: irerror.h,v 1.2 1993/12/13 20:21:49 irsuprt Exp irsuprt $
 * $Log: irerror.h,v $
 * Revision 1.2  1993/12/13  20:21:49  irsuprt
 * V1.2: removed decl. for error_message[][] for not ANSI compliance
 *
 * Revision 1.1  1993/11/01  17:03:51  irsuprt
 * Initial revision
 *
 *
 *****************************************************************************/

#define YES 1
#define NO  0

#define MAX_ERROR_MESSAGES          75

#define SUCCESS                                          0
#define ERR_PROTOCOL                                     1
#define ERR_LOW_MEMORY                                   2
#define ERR_CREATE_SOCKET                                3
#define ERR_BIND_SOCKET                                  4
#define ERR_ACCEPT_CONNECT                               5
#define ERR_TIMEOUT                                      6
#define ERR_CONVERT_BER                                  7
#define ERR_CREATE_TCP_HANDLER                           8
#define ERR_RPC_CALL_FAIL                                9
#define ERR_ALLOCATE_MEMORY                              10
#define ERR_INVOKE_INIT_PROCESS                          11
#define ERR_INVOKE_TERM_PROCESS                          12
#define ERR_TALK_TO_INIT_PROCESS                         13
#define ERR_TALK_TO_QRM_PROCESS                          14
#define ERR_NO_RESPONSE_FROM_ORIGIN                      15
#define ERR_NO_RESPONSE_FROM_TP                          16
#define ERR_TALK_TO_ORIGIN                               17
#define ERR_ABORT_FROM_TARGET_PROC                       18
#define ERR_DUPLICATE_CLIENT                             19
#define ERR_CANNOT_GET_HOST_NAME                         20
#define ERR_CLIENT_NOT_IN_LIST                           21
#define ERR_OPEN_WRITE_FILE                              22
#define ERR_INTERNAL_SYSTEM_ERROR                        23
#define ERR_GET_SOCKET_NAME                              24
#define ERR_SEND_DATA_TO_IR_FROM_TP                      25
#define ERR_DECODE_APDU                                  26
#define ERR_FIND_APDU_LENGTH                             27
#define ERR_SET_SOCKET_OPTIONS                           28
#define ERR_LISTEN_SOCKET                                29
#define ERR_SELECT_TCP_PORT                              30
#define ERR_INVALID_QRM_APDU                             31
#define ERR_QUERY_TYPE_NOT_SUPPORTED                     32
#define ERR_INVALID_INIT_REQUEST_OPTIONS                 33
#define ERR_INVALID_INIT_MESS_SIZE_REQUEST               34
#define ERR_ACCESS_CONTROL_FAILED                        35
#define ERR_RESOURCE_CONTROL_FAILED                      36
#define ERR_IDLE_TIMEOUT                                37
#define ERR_INCOMPLETE_DEFAULT_FILE                      38
#define ERR_INVALID_INIT_PROTOCOL_VERSION                39
#define ERR_EMPTY_INIT_PROTOCOL_VERSION                  40
#define ERR_EMPTY_INIT_PREFERRED_MESSAGE_SIZE            41
#define ERR_EMPTY_INIT_MAXIMUM_RECORD_SIZE               42
#define ERR_EMPTY_INIT_RESP_RESULT                       43
#define ERR_SEARCH_SMALL_SET_IS_INVALID                  44
#define ERR_SEARCH_SMALL_SET_IS_TOO_LARGE                45
#define ERR_SEARCH_MEDIUM_SET_IS_TOO_LARGE               46
#define ERR_SEARCH_LARGE_SET_IS_INVALID                  47
#define ERR_INVALID_SEARCH_REPLACE_INDICATOR             48
#define ERR_EMPTY_SEARCH_RESULT_SET_NAME                 49
#define ERR_EMPTY_SEARCH_DATABASE_NAME                   50
#define ERR_INVALID_SEARCH_QUERY_TYPE                    51
#define ERR_EMPTY_SEARCH_QUERY                           52
#define ERR_EMPTY_PRESENT_RESULT_SET_ID                  53
#define ERR_EMPTY_PRESENT_RESULT_SET_START_POINT         54
#define ERR_EMPTY_PRESENT_NUMBER_RECORDS_REQUESTED       55
#define ERR_INVALID_DELETE_OPERATION                     56
#define ERR_INVALID_TRIGGER_RESOURCE_REQUEST_OPERATION   57
#define ERR_CANNOT_GET_DOMAIN_NAME                       58
#define ERR_SEND_DATA_TO_CLIENT                          59
#define ERR_EMPTY_SEARCH_RESP_RESULT_COUNT               60
#define ERR_EMPTY_SEARCH_RESP_NO_OF_RECS_RETURN          61
#define ERR_EMPTY_SEARCH_RESP_NEXT_RESULT_SET_POSITION   62
#define ERR_EMPTY_SEARCH_RESP_SEARCH_STATUS              63
#define ERR_EMPTY_PRESENT_RESP_NO_OF_RECS_RETURN         64
#define ERR_EMPTY_PRESENT_RESP_NEXT_RESULT_SET_POSITION  65
#define ERR_EMPTY_PRESENT_RESP_PRESENT_STATUS            66
#define ERR_INVALID_DELETE_OPERATION_STATUS              67
#define ERR_INVALID_RESOURCE_REPORT_STATUS               68
#define ERR_ENCODE_APDU                                  69

#define DISPLAY_USER_ERROR                               99
 
extern int fatal_error[];

extern char ERR_STR[];
extern char ERROR_FILE_NAME[];

extern FILE *ERROR_FILE;

extern void ir_init_error_messages();
extern int display_error(char msg[], int error_code, int extra_error_code);


